/*
 * Copyright 2008-2009 Michael Lotz <mmlr@mlotz.ch>
 * Distributed under the terms of the MIT license.
 */
#ifndef USB_GAMEPAD_DEVICE_H
#define USB_GAMEPAD_DEVICE_H


#include <InterfaceDefs.h>

#include "ProtocolHandler.h"
#include "joystick_driver.h"

class HIDReportItem;


#ifndef B_MAX_JOYSTICK_BUTTONS
#	define B_MAX_JOYSTICK_BUTTONS		32
#endif


class GamepadDevice : public ProtocolHandler {
public:
								GamepadDevice(HIDReport *report,
									HIDReportItem *xAxis, HIDReportItem *yAxis);

	static	ProtocolHandler *	AddHandler(HIDDevice *device,
									HIDReport *report);

	virtual	status_t			Control(uint32 *cookie, uint32 op, void *buffer,
									size_t length);
									
private:
			status_t			_ReadReport();
			uint32				NumButtons();
			uint32				NumAxes();

private:
			HIDReport *			fReport;

			HIDReportItem *		fXAxis;
			HIDReportItem *		fYAxis;
			HIDReportItem *		fButtons[B_MAX_JOYSTICK_BUTTONS];

			uint32				fNumButtons;
			uint32				fNumAxes;
			bigtime_t			fLastClickTime;
			bigtime_t			fClickSpeed;
			joystick_module_info	fJoyModInfo;
};

#endif // USB_GAMEPAD_DEVICE_H
